using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace DisSharp.Examples
{

	[Description("Big Switch produces very complex assembler code")]
	public class BigSwitch
	{

		public string S;

		public BigSwitch()
		{
		}

		protected virtual void WndProc(ref Message m)
		{
			switch (m.Msg)
			{
				case 0x3D:
					S = "0x3D";
					break;

				case 0x111:
					S = "0x111";
					break;

				case 0x10:
					S = "0x10";
					break;

				case 0x7B:
					S = "0x7B";
					break;

				case 0x7E:
					S = "0x7E";
					break;

				case 0x2B:
					S = "0x2B";
					break;

				case 0x14:
					S = "0x14";
					break;

				case 0x53:
					S = "0x53";
					break;

				case 0xF:
					S = "0xF";
					break;

				case 0x318:
					S = "0x318";
					break;

				case 0x117:
					S = "0x117";
					break;

				case 0x51:
					S = "0x51";
					break;

				case 0x50:
					S = "0x50";
					break;

				case 0x2C:
					S = "0x2C";
					break;

				case 0x120:
					S = "0x120";
					break;

				case 0x11F:
					S = "0x11F";
					break;

				case 0x20:
					S = "0x20";
					break;

				case 0x46:
					S = "0x46";
					break;

				case 0x100:
				case 0x101:
				case 0x102:
				case 0x104:
				case 0x105:
					S = "0x100-0x105";
					break;

				case 1:
					S = "1";
					break;

				case 2:
					S = "2";
					break;

				case 0x19:
				case 0x132:
				case 0x133:
				case 0x134:
				case 0x135:
				case 0x136:
				case 0x137:
				case 0x138:
					S = "0x19-0x138";
					break;

				case 0x2D:
				case 0x2E:
				case 0x2F:
				case 0x39:
				case 0x114:
				case 0x115:
					S = "0x2D-0x115";
					break;

				case 0x286:
					S = "0x286";
					break;

				case 8:
					S = "8";
					break;

				case 0x203:
					S = "0x203";
					break;

				case 0x201:
					S = "0x201";
					break;

				case 0x202:
					S = "0x202";
					break;

				case 0x209:
					S = "0x209";
					break;

				case 0x207:
					S = "0x207";
					break;

				case 0x208:
					S = "0x208";
					break;

				case 0x20B:
					S = "0x20B";
					break;

				case 0x20C:
					S = "0x20C";
					break;

				case 0x20D:
					S = "0x20D";
					break;

				case 0x2A3:
					S = "0x2A3";
					break;

				case 0x200:
					S = "0x200";
					break;

				case 0x20A:
					S = "0x20A";
					break;

				case 3:
					S = "3";
					break;

				case 0x4E:
					S = "0x4E";
					break;

				case 0x55:
					S = "0x55";
					break;

				case 0x2055:
					S = "0x2055";
					break;

				case 0x18:
					S = "0x18";
					break;

				case 0x206:
					S = "0x206";
					break;

				case 0x204:
					S = "0x204";
					break;

				case 0x205:
					S = "0x205";
					break;

				case 7:
					S = "7";
					break;

				case 0x15:
					S = "0x15";
					break;

				case 0x2A1:
					S = "0x2A1";
					break;

				case 0x47:
					S = "0x47";
					break;

				case 0x30F:
					S = "0x30F";
					break;

				case 0x128:
					S = "0x128";
					break;

				case 0x210:
					S = "0x210";
					break;

				case 4:
				case 5:
				case 6:
				case 0x11:
				case 0x12:
				case 0x13:
				case 0x16:
				case 0x17:
				case 0x4F:
				case 0x52:
				case 0x54:
				case 0x103:
				case 0x112:
				case 0x113:
				case 0x116:
				case 0x20E:
				case 0x20F:
				case 0x2A2:
					S = "4-0x2A2";
					break;

				default:
					break;
			}
		}

		// to see example in a trial version
		private void Z_TrialStub_1() {}
		private void Z_TrialStub_2() {}

	}

}

